package cn.superdesk.uniorder.dubbo.consumer.invoice.supplier;

import cn.superdesk.uniorder.common.security.JwtUtil;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.invoice.supplier.InvoiceApplySupplier;
import cn.superdesk.uniorder.dto.param.invoice.supplier.status.InvoiceApplySupplierOpCommonDimAccountingOrderForm;
import cn.superdesk.uniorder.dubbo.consumer._permission.PermissionDubboCustomerService;
import cn.superdesk.uniorder.dubbo.facade.invoice.supplier.DubboInvoiceApplySupplierFieldPayoffAccountStatusService;
import com.alibaba.dubbo.config.annotation.Reference;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;


/**
 * @Description: 简易状态机 星型结构
 * @Author: linjinyu
 * @CreateDate: 10/12/20 4:28 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 10/12/20 4:28 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Component
public class InvoiceApplySupplierFieldPayoffAccountStatusDubboConsumerService {

	@Reference(version = "1.0.0", timeout = 300000, retries = -1)
	private DubboInvoiceApplySupplierFieldPayoffAccountStatusService dubboInvoiceApplySupplierFieldPayoffAccountStatusService;

	@Resource
	private PermissionDubboCustomerService permissionDubboCustomerService;

	/****************************************** 状态机 外部使用 类门面 start ******************************************/

	// 状态流转为 待付款(0, "待付款")
	public int opInit(String token, InvoiceApplySupplier entity) {
		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
		return dubboInvoiceApplySupplierFieldPayoffAccountStatusService.opInit(entity, loginSysUser);
	}

	// 状态流转为 付款中(10, "付款中")
	public int opRegulatoryPipeline(String token, InvoiceApplySupplier entity) {
		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
		return dubboInvoiceApplySupplierFieldPayoffAccountStatusService.opRegulatoryPipeline(entity, loginSysUser);
	}

	// 状态流转为 付款中(10, "付款中")
	public int opRegulatoryPipeline(String token, List<InvoiceApplySupplier> entitys, InvoiceApplySupplierOpCommonDimAccountingOrderForm form) {
		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
		return dubboInvoiceApplySupplierFieldPayoffAccountStatusService.opRegulatoryPipeline(entitys, form, loginSysUser);
	}

	// 状态流转为 部分付款(1, "部分付款")
	public int opPart(String token, InvoiceApplySupplier entity) {
		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
		return dubboInvoiceApplySupplierFieldPayoffAccountStatusService.opPart(entity, loginSysUser);
	}

	// 状态流转为 已付款(2, "已付款")
	public int opComplete(String token, InvoiceApplySupplier entity) {
		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
		return dubboInvoiceApplySupplierFieldPayoffAccountStatusService.opComplete(entity, loginSysUser);
	}

	// 状态流转为 已付款(2, "已付款")
	public int opComplete(String token, List<InvoiceApplySupplier> entitys, InvoiceApplySupplierOpCommonDimAccountingOrderForm form) {
		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
		return dubboInvoiceApplySupplierFieldPayoffAccountStatusService.opComplete(entitys, form, loginSysUser);
	}

	/****************************************** 状态机 外部使用 类门面   end ******************************************/
}
